using e_suite.API.Common.models;
using e_suite.Utilities.Pagination;
using Microsoft.AspNetCore.Mvc;
using Moq;
using NUnit.Framework;

namespace eSuite.API.UnitTests.Controllers.UserManagerControllerUnitTests;

[TestFixture]
public class GetUsersUnitTests : UserManagerControllerTestBase
{
    [SetUp]
    public override async Task Setup()
    {
        await base.Setup();
    }

    [Test]
    public async Task GetUsers_WhenCalled_ReturnsPagedData()
    {
        //Arrange
        var domains = new List<GetUser>();

        var paginatedData = new PaginatedData<GetUser>
        {
            Count = domains.Count,
            Data = domains,
            Page = 1,
            PageSize = 10
        };

        var cancellationToken = CancellationToken.None;

        var paging = new Paging();

        _userManagerMock.Setup(x => x.GetUsersAsync(paging, cancellationToken)).ReturnsAsync(paginatedData);

        //Act
        var actualResult = await _userManagerController.GetUsers(paging, cancellationToken);

        //Assert
        Assert.That(actualResult.GetType(), Is.EqualTo(typeof(OkObjectResult)));
        var objectResult = actualResult as OkObjectResult;

        Assert.That(objectResult?.StatusCode, Is.EqualTo(200));
        Assert.That(objectResult?.Value, Is.Not.Null);
        Assert.That(objectResult!.Value!.GetType, Is.EqualTo(typeof(PaginatedData<GetUser>)));
    }
}